# generated by datamodel-codegen:
#   filename:  v2.json
#   timestamp: 2025-01-15T15:35:52+00:00

from __future__ import annotations

from dataclasses import dataclass
from datetime import datetime
from enum import Enum
from typing import Optional, Union

from pydantic.dataclasses import dataclass

FeatureFlags = Optional[dict[str, Union[bool, str]]]


@dataclass
class Pagination:
    cursor: str


@dataclass
class EmptyResponse:
    pass


@dataclass
class AddProjectJWKSRequest:
    jwks_url: str
    provider_name: str
    role_names: list[str]
    branch_id: Optional[str] = None
    jwt_audience: Optional[str] = None


@dataclass
class JWKS:
    id: str
    project_id: str
    jwks_url: str
    provider_name: str
    created_at: str
    updated_at: str
    branch_id: Optional[str] = None
    jwt_audience: Optional[str] = None


@dataclass
class ProjectJWKSResponse:
    jwks: list[JWKS]


@dataclass
class ApiKeyCreateRequest:
    key_name: str


@dataclass
class OrgApiKeyCreateRequest(ApiKeyCreateRequest):
    project_id: Optional[str] = None


@dataclass
class ApiKeyCreateResponse:
    id: int
    key: str
    name: str
    created_at: str
    created_by: str


@dataclass
class OrgApiKeyCreateResponse(ApiKeyCreateResponse):
    project_id: Optional[str] = None


@dataclass
class ApiKeyRevokeResponse:
    id: int
    name: str
    created_at: str
    created_by: str
    last_used_from_addr: str
    revoked: bool
    last_used_at: Optional[str] = None


@dataclass
class OrgApiKeyRevokeResponse(ApiKeyRevokeResponse):
    project_id: Optional[str] = None


@dataclass
class ApiKeyCreatorData:
    id: str
    name: str
    image: str


class OperationAction(Enum):
    create_compute = 'create_compute'
    create_timeline = 'create_timeline'
    start_compute = 'start_compute'
    suspend_compute = 'suspend_compute'
    apply_config = 'apply_config'
    check_availability = 'check_availability'
    delete_timeline = 'delete_timeline'
    create_branch = 'create_branch'
    tenant_ignore = 'tenant_ignore'
    tenant_attach = 'tenant_attach'
    tenant_detach = 'tenant_detach'
    tenant_reattach = 'tenant_reattach'
    replace_safekeeper = 'replace_safekeeper'
    disable_maintenance = 'disable_maintenance'
    apply_storage_config = 'apply_storage_config'
    prepare_secondary_pageserver = 'prepare_secondary_pageserver'
    switch_pageserver = 'switch_pageserver'
    detach_parent_branch = 'detach_parent_branch'
    timeline_archive = 'timeline_archive'
    timeline_unarchive = 'timeline_unarchive'
    start_reserved_compute = 'start_reserved_compute'
    sync_dbs_and_roles_from_compute = 'sync_dbs_and_roles_from_compute'


class OperationStatus(Enum):
    scheduling = 'scheduling'
    running = 'running'
    finished = 'finished'
    failed = 'failed'
    error = 'error'
    cancelling = 'cancelling'
    cancelled = 'cancelled'
    skipped = 'skipped'


@dataclass
class Branch:
    name: Optional[str] = None
    role_name: Optional[str] = None
    database_name: Optional[str] = None


@dataclass
class ProjectPermission:
    id: str
    granted_to_email: str
    granted_at: str
    revoked_at: Optional[str] = None


@dataclass
class ProjectPermissions:
    project_permissions: list[ProjectPermission]


@dataclass
class GrantPermissionToProjectRequest:
    email: str


@dataclass
class ConsumptionHistoryPerTimeframe:
    timeframe_start: str
    timeframe_end: str
    active_time_seconds: int
    compute_time_seconds: int
    written_data_bytes: int
    synthetic_storage_size_bytes: int
    data_storage_bytes_hour: Optional[int] = None


class ConsumptionHistoryGranularity(Enum):
    hourly = 'hourly'
    daily = 'daily'
    monthly = 'monthly'


@dataclass
class Limits:
    active_time: int
    max_projects: int
    max_branches: int
    max_protected_branches: int
    max_autoscaling_cu: float
    max_fixed_size_cu: float
    cpu_seconds: int
    max_compute_time_non_primary: int
    max_active_endpoints: int
    max_read_only_endpoints: int
    max_allowed_ips: int
    max_vpc_endpoints_per_region: int
    max_monitoring_retention_hours: int
    max_history_retention_seconds: int
    min_autosuspend_seconds: int
    max_data_transfer: int
    min_idle_seconds_to_autoarchive: int
    min_age_seconds_to_autoarchive: int
    max_branch_roles: int
    max_branch_databases: int
    max_concurrent_scheduled_operation_chains_per_project: int
    max_concurrent_executing_operation_chains_per_project: int


@dataclass
class CreatedBy:
    name: Optional[str] = None
    image: Optional[str] = None


@dataclass
class Branch2:
    parent_id: Optional[str] = None
    name: Optional[str] = None
    parent_lsn: Optional[str] = None
    parent_timestamp: Optional[str] = None
    protected: Optional[bool] = None
    archived: Optional[bool] = None
    init_source: Optional[str] = None


@dataclass
class Branch3:
    name: Optional[str] = None
    protected: Optional[bool] = None


@dataclass
class BranchUpdateRequest:
    branch: Branch3


@dataclass
class BranchRestoreRequest:
    source_branch_id: str
    source_lsn: Optional[str] = None
    source_timestamp: Optional[str] = None
    preserve_under_name: Optional[str] = None


@dataclass
class BranchSchemaResponse:
    sql: Optional[str] = None


@dataclass
class BranchSchemaCompareResponse:
    diff: Optional[str] = None


@dataclass
class BranchesCountResponse:
    count: int


@dataclass
class ConnectionParameters:
    database: str
    password: str
    role: str
    host: str
    pooler_host: str


@dataclass
class ConnectionDetails:
    connection_uri: str
    connection_parameters: ConnectionParameters


@dataclass
class ConnectionURIResponse:
    uri: str


class EndpointState(Enum):
    init = 'init'
    active = 'active'
    idle = 'idle'


class EndpointType(Enum):
    read_only = 'read_only'
    read_write = 'read_write'


class EndpointPoolerMode(Enum):
    transaction = 'transaction'


@dataclass
class AllowedIps:
    ips: Optional[list[str]] = None
    protected_branches_only: Optional[bool] = None


@dataclass
class MaintenanceWindow:
    weekdays: list[int]
    start_time: str
    end_time: str


@dataclass
class ConnectionURIsResponse:
    connection_uris: list[ConnectionDetails]


@dataclass
class ConnectionURIsOptionalResponse:
    connection_uris: Optional[list[ConnectionDetails]] = None


@dataclass
class VPCEndpoint:
    vpc_endpoint_id: str
    label: str


@dataclass
class VPCEndpointDetails:
    vpc_endpoint_id: str
    label: str
    state: str
    num_restricted_projects: int
    example_restricted_projects: list[str]


@dataclass
class VPCEndpointAssignment:
    label: str


@dataclass
class EndpointPasswordlessSessionAuthRequest:
    session_id: str


Duration = int


@dataclass
class StatementData:
    truncated: bool
    fields: Optional[list[str]] = None
    rows: Optional[list[list[str]]] = None


@dataclass
class ExplainData:
    QUERY_PLAN: str


@dataclass
class Role:
    branch_id: str
    name: str
    created_at: str
    updated_at: str
    password: Optional[str] = None
    protected: Optional[bool] = None


@dataclass
class Role1:
    name: str


@dataclass
class RoleCreateRequest:
    role: Role1


@dataclass
class RoleResponse:
    role: Role


@dataclass
class JWKSResponse:
    jwks: JWKS


@dataclass
class RolesResponse:
    roles: list[Role]


@dataclass
class RolePasswordResponse:
    password: str


class Brand(Enum):
    amex = 'amex'
    diners = 'diners'
    discover = 'discover'
    jcb = 'jcb'
    mastercard = 'mastercard'
    unionpay = 'unionpay'
    unknown = 'unknown'
    visa = 'visa'


@dataclass
class PaymentSourceBankCard:
    last4: str
    brand: Optional[Brand] = None
    exp_month: Optional[int] = None
    exp_year: Optional[int] = None


@dataclass
class PaymentSource:
    type: str
    card: Optional[PaymentSourceBankCard] = None


class BillingAccountState(Enum):
    UNKNOWN = 'UNKNOWN'
    active = 'active'
    suspended = 'suspended'
    deactivated = 'deactivated'
    deleted = 'deleted'


class BillingSubscriptionType(Enum):
    UNKNOWN = 'UNKNOWN'
    direct_sales = 'direct_sales'
    aws_marketplace = 'aws_marketplace'
    free_v2 = 'free_v2'
    launch = 'launch'
    scale = 'scale'
    business = 'business'
    vercel_pg_legacy = 'vercel_pg_legacy'


class BillingPaymentMethod(Enum):
    UNKNOWN = 'UNKNOWN'
    none = 'none'
    stripe = 'stripe'
    direct_payment = 'direct_payment'
    aws_mp = 'aws_mp'
    azure_mp = 'azure_mp'
    vercel_mp = 'vercel_mp'
    staff = 'staff'
    trial = 'trial'
    sponsorship = 'sponsorship'


@dataclass
class Database:
    id: int
    branch_id: str
    name: str
    owner_name: str
    created_at: str
    updated_at: str


@dataclass
class Database1:
    name: str
    owner_name: str


@dataclass
class DatabaseCreateRequest:
    database: Database1


@dataclass
class Database2:
    name: Optional[str] = None
    owner_name: Optional[str] = None


@dataclass
class DatabaseUpdateRequest:
    database: Database2


@dataclass
class DatabaseResponse:
    database: Database


@dataclass
class DatabasesResponse:
    databases: list[Database]


class MemberRole(Enum):
    admin = 'admin'
    member = 'member'


@dataclass
class Member:
    id: str
    user_id: str
    org_id: str
    role: MemberRole
    joined_at: Optional[str] = None


@dataclass
class MemberUserInfo:
    email: str


@dataclass
class MemberWithUser:
    member: Member
    user: MemberUserInfo


@dataclass
class Organization:
    id: str
    name: str
    handle: str
    plan: str
    created_at: str
    managed_by: str
    updated_at: str


@dataclass
class OrganizationsResponse:
    organizations: list[Organization]


@dataclass
class OrganizationsUpdateRequest:
    name: str


@dataclass
class OrganizationInviteCreateRequest:
    email: str
    role: MemberRole


@dataclass
class OrganizationInvitesCreateRequest:
    invitations: list[OrganizationInviteCreateRequest]


@dataclass
class OrganizationInviteUpdateRequest:
    email: Optional[str] = None
    role: Optional[MemberRole] = None
    resend: Optional[bool] = None


@dataclass
class OrganizationGuest:
    permission_id: str
    user_email: str
    project_id: str
    project_name: str


@dataclass
class OrganizationMemberUpdateRequest:
    role: MemberRole


@dataclass
class OrganizationMembersResponse:
    members: list[MemberWithUser]


@dataclass
class InvitationCreateRequest:
    email: str
    role: MemberRole


@dataclass
class Organization1:
    name: Optional[str] = None
    invitations: Optional[list[InvitationCreateRequest]] = None


@dataclass
class OrganizationCreateRequest:
    organization: Organization1
    subscription_type: BillingSubscriptionType


@dataclass
class OrganizationLimits:
    limits: Limits
    features: dict[str, bool]


@dataclass
class RegionResponse:
    region_id: str
    name: str
    default: bool
    geo_lat: str
    geo_long: str


@dataclass
class UpdateUserInfoRequest:
    id: str
    email: Optional[str] = None
    image: Optional[str] = None
    first_name: Optional[str] = None
    last_name: Optional[str] = None
    password: Optional[str] = None
    new_password: Optional[str] = None


@dataclass
class ConvertUserToOrgRequest:
    name: str


@dataclass
class TransferProjectsToOrganizationRequest:
    org_id: str
    project_ids: list[str]


@dataclass
class VerifyUserPasswordRequest:
    password: str


class IdentityProviderId(Enum):
    github = 'github'
    google = 'google'
    hasura = 'hasura'
    microsoft = 'microsoft'
    microsoftv2 = 'microsoftv2'
    vercelmp = 'vercelmp'
    keycloak = 'keycloak'
    test = 'test'


@dataclass
class ProjectQuota:
    active_time_seconds: Optional[int] = None
    compute_time_seconds: Optional[int] = None
    written_data_bytes: Optional[int] = None
    data_transfer_bytes: Optional[int] = None
    logical_size_bytes: Optional[int] = None


@dataclass
class HealthCheck:
    status: str


@dataclass
class ProjectOwnerData:
    email: str
    name: str
    branches_limit: int
    subscription_type: BillingSubscriptionType


@dataclass
class Limit:
    name: str
    expected: str
    actual: str


@dataclass
class LimitsUnsatisfiedResponse:
    limits: list[Limit]


@dataclass
class Project3:
    id: str
    integration: str


@dataclass
class ProjectsWithIntegrationResponse:
    projects: list[Project3]


class UserDeletionConditionName(Enum):
    project_count = 'project_count'
    org_admin_membership_count = 'org_admin_membership_count'
    subscription_type = 'subscription_type'


class OrgDeletionConditionName(Enum):
    project_count = 'project_count'


class IdentitySupportedAuthProvider(Enum):
    mock = 'mock'
    stack = 'stack'


@dataclass
class IdentityIntegration:
    auth_provider: str
    auth_provider_project_id: str
    branch_id: str
    db_name: str
    created_at: str


class SupportTicketSeverity(Enum):
    low = 'low'
    normal = 'normal'
    high = 'high'
    critical = 'critical'


@dataclass
class AnnotationObjectData:
    type: str
    id: str


@dataclass
class AnnotationCreateValueRequest:
    annotation_value: Optional[dict[str, str]] = None


class Application(Enum):
    vercel = 'vercel'
    github = 'github'
    datadog = 'datadog'


@dataclass
class ProjectsApplicationsMapResponse:
    applications: dict[str, list[Application]]


class Integration(Enum):
    vercel = 'vercel'
    github = 'github'
    datadog = 'datadog'


@dataclass
class ProjectsIntegrationsMapResponse:
    integrations: dict[str, list[Integration]]


@dataclass
class CursorPagination:
    next: Optional[str] = None
    previous: Optional[str] = None
    sort_by: Optional[str] = None
    sort_order: Optional[str] = None


@dataclass
class PaginationResponse:
    pagination: Optional[Pagination] = None


@dataclass
class ApiKeysListResponseItem:
    id: int
    name: str
    created_at: str
    created_by: ApiKeyCreatorData
    last_used_from_addr: str
    last_used_at: Optional[str] = None


@dataclass
class OrgApiKeysListResponseItem(ApiKeysListResponseItem):
    project_id: Optional[str] = None


@dataclass
class Operation:
    id: str
    project_id: str
    action: OperationAction
    status: OperationStatus
    failures_count: int
    created_at: str
    updated_at: str
    total_duration_ms: int
    branch_id: Optional[str] = None
    endpoint_id: Optional[str] = None
    error: Optional[str] = None
    retry_at: Optional[str] = None


@dataclass
class OperationResponse:
    operation: Operation


@dataclass
class OperationsResponse:
    operations: list[Operation]


@dataclass
class ProjectSettingsData:
    quota: Optional[ProjectQuota] = None
    allowed_ips: Optional[AllowedIps] = None
    enable_logical_replication: Optional[bool] = None
    maintenance_window: Optional[MaintenanceWindow] = None
    block_public_connections: Optional[bool] = None
    block_vpc_connections: Optional[bool] = None


@dataclass
class ConsumptionHistoryPerPeriod:
    period_id: str
    period_plan: str
    period_start: str
    consumption: list[ConsumptionHistoryPerTimeframe]
    period_end: Optional[str] = None


@dataclass
class ProjectLimits:
    limits: Limits
    features: dict[str, bool]


@dataclass
class Branch1:
    id: str
    project_id: str
    name: str
    current_state: str
    state_changed_at: str
    creation_source: str
    default: bool
    protected: bool
    cpu_used_sec: int
    compute_time_seconds: int
    active_time_seconds: int
    written_data_bytes: int
    data_transfer_bytes: int
    created_at: str
    updated_at: str
    parent_id: Optional[str] = None
    parent_lsn: Optional[str] = None
    parent_timestamp: Optional[str] = None
    pending_state: Optional[str] = None
    logical_size: Optional[int] = None
    primary: Optional[bool] = None
    last_reset_at: Optional[str] = None
    created_by: Optional[CreatedBy] = None


@dataclass
class BranchCreateRequestEndpointOptions:
    type: EndpointType
    autoscaling_limit_min_cu: Optional[float] = None
    autoscaling_limit_max_cu: Optional[float] = None
    provisioner: Optional[str] = None
    suspend_timeout_seconds: Optional[int] = None


@dataclass
class BranchCreateRequest:
    endpoints: Optional[list[BranchCreateRequestEndpointOptions]] = None
    branch: Optional[Branch2] = None


@dataclass
class BranchResponse:
    branch: Branch1


@dataclass
class BranchesResponse:
    branches: list[Branch1]


@dataclass
class VPCEndpointsResponse:
    endpoints: list[VPCEndpoint]


@dataclass
class StatementResult:
    query: str
    data: Optional[StatementData] = None
    error: Optional[str] = None
    explain_data: Optional[list[ExplainData]] = None


@dataclass
class BillingAccount:
    state: BillingAccountState
    payment_source: PaymentSource
    subscription_type: BillingSubscriptionType
    payment_method: BillingPaymentMethod
    quota_reset_at_last: str
    name: str
    email: str
    address_city: str
    address_country: str
    address_line1: str
    address_line2: str
    address_postal_code: str
    address_state: str
    address_country_name: Optional[str] = None
    orb_portal_url: Optional[str] = None
    tax_id: Optional[str] = None
    tax_id_type: Optional[str] = None


@dataclass
class Invitation:
    id: str
    email: str
    org_id: str
    invited_by: str
    invited_at: str
    role: MemberRole


@dataclass
class OrganizationInvitationsResponse:
    invitations: list[Invitation]


OrganizationGuestsResponse = list[OrganizationGuest]


@dataclass
class ActiveRegionsResponse:
    regions: list[RegionResponse]


@dataclass
class CurrentUserAuthAccount:
    email: str
    image: str
    login: str
    name: str
    provider: IdentityProviderId


@dataclass
class LinkedAuthAccount:
    provider: IdentityProviderId
    provider_display_name: str
    username: str


@dataclass
class CurrentUserInfoResponse:
    active_seconds_limit: int
    billing_account: BillingAccount
    auth_accounts: list[CurrentUserAuthAccount]
    email: str
    id: str
    image: str
    login: str
    name: str
    last_name: str
    projects_limit: int
    branches_limit: int
    max_autoscaling_limit: float
    plan: str
    compute_seconds_limit: Optional[int] = None


@dataclass
class CurrentUserInfoAuthResponse:
    password_stored: bool
    auth_accounts: list[CurrentUserAuthAccount]
    linked_accounts: list[LinkedAuthAccount]
    provider: str


@dataclass
class EndpointSettingsData:
    pg_settings: Optional[dict[str, str]] = None
    pgbouncer_settings: Optional[dict[str, str]] = None


@dataclass
class DefaultEndpointSettings:
    pg_settings: Optional[dict[str, str]] = None
    pgbouncer_settings: Optional[dict[str, str]] = None
    autoscaling_limit_min_cu: Optional[float] = None
    autoscaling_limit_max_cu: Optional[float] = None
    suspend_timeout_seconds: Optional[int] = None


@dataclass
class ListProjectIdentityIntegrationsResponse:
    data: list[IdentityIntegration]


@dataclass
class GeneralError:
    code: str
    message: str
    request_id: Optional[str] = None


@dataclass
class BranchOperations(BranchResponse, OperationsResponse):
    pass


@dataclass
class DatabaseOperations(DatabaseResponse, OperationsResponse):
    pass


@dataclass
class RoleOperations(RoleResponse, OperationsResponse):
    pass


@dataclass
class JWKSCreationOperation(JWKSResponse, OperationsResponse):
    pass


@dataclass
class AnnotationData:
    object: AnnotationObjectData
    value: dict[str, str]
    created_at: Optional[str] = None
    updated_at: Optional[str] = None


@dataclass
class AnnotationResponse:
    annotation: AnnotationData


@dataclass
class AnnotationsMapResponse:
    annotations: dict[str, AnnotationData]


@dataclass
class CursorPaginationResponse:
    pagination: Optional[CursorPagination] = None


@dataclass
class ProjectListItem:
    id: str
    platform_id: str
    region_id: str
    name: str
    provisioner: str
    pg_version: int
    proxy_host: str
    branch_logical_size_limit: int
    branch_logical_size_limit_bytes: int
    store_passwords: bool
    active_time: int
    cpu_used_sec: int
    creation_source: str
    created_at: str
    updated_at: str
    owner_id: str
    default_endpoint_settings: Optional[DefaultEndpointSettings] = None
    settings: Optional[ProjectSettingsData] = None
    maintenance_starts_at: Optional[str] = None
    synthetic_storage_size: Optional[int] = None
    quota_reset_at: Optional[str] = None
    compute_last_active_at: Optional[str] = None
    org_id: Optional[str] = None


@dataclass
class Project:
    data_storage_bytes_hour: int
    data_transfer_bytes: int
    written_data_bytes: int
    compute_time_seconds: int
    active_time_seconds: int
    cpu_used_sec: int
    id: str
    platform_id: str
    region_id: str
    name: str
    provisioner: str
    pg_version: int
    proxy_host: str
    branch_logical_size_limit: int
    branch_logical_size_limit_bytes: int
    store_passwords: bool
    creation_source: str
    history_retention_seconds: int
    created_at: str
    updated_at: str
    consumption_period_start: str
    consumption_period_end: str
    owner_id: str
    default_endpoint_settings: Optional[DefaultEndpointSettings] = None
    settings: Optional[ProjectSettingsData] = None
    maintenance_starts_at: Optional[str] = None
    synthetic_storage_size: Optional[int] = None
    quota_reset_at: Optional[str] = None
    owner: Optional[ProjectOwnerData] = None
    compute_last_active_at: Optional[str] = None
    org_id: Optional[str] = None


@dataclass
class Project1:
    settings: Optional[ProjectSettingsData] = None
    name: Optional[str] = None
    branch: Optional[Branch] = None
    autoscaling_limit_min_cu: Optional[float] = None
    autoscaling_limit_max_cu: Optional[float] = None
    provisioner: Optional[str] = None
    region_id: Optional[str] = None
    default_endpoint_settings: Optional[DefaultEndpointSettings] = None
    pg_version: Optional[int] = None
    store_passwords: Optional[bool] = None
    history_retention_seconds: Optional[int] = None
    org_id: Optional[str] = None


@dataclass
class ProjectCreateRequest:
    project: Project1


@dataclass
class Project2:
    settings: Optional[ProjectSettingsData] = None
    name: Optional[str] = None
    default_endpoint_settings: Optional[DefaultEndpointSettings] = None
    history_retention_seconds: Optional[int] = None


@dataclass
class ProjectUpdateRequest:
    project: Project2


@dataclass
class ProjectResponse:
    project: Project


@dataclass
class ProjectsResponse:
    projects: list[ProjectListItem]
    unavailable_project_ids: Optional[list[str]] = None


@dataclass
class ConsumptionHistoryPerAccountResponse:
    periods: list[ConsumptionHistoryPerPeriod]


@dataclass
class ConsumptionHistoryPerProject:
    project_id: str
    periods: list[ConsumptionHistoryPerPeriod]


@dataclass
class Endpoint:
    host: str
    id: str
    project_id: str
    branch_id: str
    autoscaling_limit_min_cu: float
    autoscaling_limit_max_cu: float
    region_id: str
    type: EndpointType
    current_state: EndpointState
    settings: EndpointSettingsData
    pooler_enabled: bool
    pooler_mode: EndpointPoolerMode
    disabled: bool
    passwordless_access: bool
    creation_source: str
    created_at: str
    updated_at: str
    proxy_host: str
    suspend_timeout_seconds: int
    provisioner: str
    pending_state: Optional[EndpointState] = None
    last_active: Optional[str] = None
    compute_release_version: Optional[str] = None


@dataclass
class Endpoint1:
    branch_id: str
    type: EndpointType
    region_id: Optional[str] = None
    settings: Optional[EndpointSettingsData] = None
    autoscaling_limit_min_cu: Optional[float] = None
    autoscaling_limit_max_cu: Optional[float] = None
    provisioner: Optional[str] = None
    pooler_enabled: Optional[bool] = None
    pooler_mode: Optional[EndpointPoolerMode] = None
    disabled: Optional[bool] = None
    passwordless_access: Optional[bool] = None
    suspend_timeout_seconds: Optional[int] = None


@dataclass
class EndpointCreateRequest:
    endpoint: Endpoint1


@dataclass
class Endpoint2:
    branch_id: Optional[str] = None
    autoscaling_limit_min_cu: Optional[float] = None
    autoscaling_limit_max_cu: Optional[float] = None
    provisioner: Optional[str] = None
    settings: Optional[EndpointSettingsData] = None
    pooler_enabled: Optional[bool] = None
    pooler_mode: Optional[EndpointPoolerMode] = None
    disabled: Optional[bool] = None
    passwordless_access: Optional[bool] = None
    suspend_timeout_seconds: Optional[int] = None


@dataclass
class EndpointUpdateRequest:
    endpoint: Endpoint2


@dataclass
class EndpointResponse:
    endpoint: Endpoint


@dataclass
class EndpointsResponse:
    endpoints: list[Endpoint]


@dataclass
class EndpointOperations(EndpointResponse, OperationsResponse):
    pass


@dataclass
class ConsumptionHistoryPerProjectResponse:
    projects: list[ConsumptionHistoryPerProject]
